-- класс для переходов
Path = Class {
	['before_Walk,Enter'] = function(s)
		local r, v = mp:runorval(s, 'cant_go')
		if type(r) == "string" then p(r) end
		if v then return end
		local o = std.call(s, 'walk_to')
		if mp:check_inside(_(o)) then
			return
		end
		if _(o):has 'door' then
			mp:xaction("Enter", _(o))
			return
		end
		walk(o)
	end;
	before_Default = function(s, ev)
		if (ev == 'Exam' or ev == 'LookAt') and s.description then
			return false
		end
		if s.desc then
			if type(s.desc) == 'function' then
				s:desc()
			else
				p(s.desc)
			end
			return
		end
		p ([[{#Me} {#word/могу,#me,нст} пойти в ]], std.ref(s.walk_to):noun('вн'), '.');
	end;
	default_Event = 'Walk';
	}:attr'scenery,enterable';

Useless = Class {
	before_Default = function(s, ev)
		if ev == "Exam" or ev == "Look" or ev == "Search" then
			return false
		end
		p ("Я решаю оставить ", s:noun 'вн', " в покое.")
	end;
	}:attr 'scenery'

Ephe = Class {
	description = "Это не предмет.";
	before_Default = function(s, ev, o)
--		pn(ev)
		if ev == "Exam" or ev == "Look" or ev == "Search" then
			return false
		end
		--pn("ev = ",ev,"   o = ",o)
		p ("Предложите что-то более дельное.");
	end;
	}:attr 'scenery'

-- классы для локаций снаружи и внутри станции, чтобы описать разные вещи (дно, воду, стены) и специфичные действия (попытки снять скафандр, например)
Useless {
	-"дно,песок",
	description = "Морское дно у меня под ногами.",
	found_in = function(s)
		return not not here().is_outside;
	end,
	before_Take = "Мне не нужен песок.",
}

Useless {
	-"вода",
	description = "Вода окружает меня. Это океан, в конце концов.",
	found_in = function(s)
		return not not here().is_outside;
	end,
}

Useless {
	-"поверхность",
	nam = 'surface',
	description = "До неё очень далеко.",
	["before_Walk,Enter"] = "До поверхности примерно шесть тысяч метров. Единственный способ её достичь — подняться в батискафе.",
	found_in = function(s)
		return true;
	end,
}

Useless {
	-"стена|стены|пол|потолок",
	description = "Ничего примечательного.",
	found_in = function(s)
		return not not here().is_inside;
	end,
}

Outside = Class({
		is_outside = true,
		u_to = 'surface',
		before_Disrobe = function(s,o) 
			if o ^ 'suit' then
				p "Я не хочу погибнуть."
				return true
			else
				return false
			end
		end,
		["before_Eat,Drink,Taste,Smell"] = function(s,o)
			if o^'suit' then
				return false
			else
				p "В скафандре это невозможно."
			end
		end,
		before_Swim = "Глубоководный скафандр очень тяжёл, в нём не поплаваешь."
		}, room)

Inside = Class({
		is_inside = true,
		before_Any = function(s,ev,o)
			local walk = (ev == 'Walk') or (ev == 'Enter')
			if walk and (o^'@out_to') then return false end
			local walk_outside = walk and o and o.to_outside
			local walk_inside = walk and o and (not o.to_outside)
			local in_suit = _('suit'):has "worn"
			--p (ev," ",o," walk=", walk,"  walk_inside=", walk_inside)
			if walk_inside and in_suit and s:once 'walk_in_suit' then
				p "Передвигаться по Станции в скафандре практически невозможно."
				return true
			end
			if in_suit and (ev ~= 'LetIn') and (ev ~= 'Disrobe') and (ev ~= 'Look') and 
			(ev ~= 'Exam') and (ev ~= 'LookAt') and (ev ~= 'Inv') and (ev ~= 'Take') and 
			(ev ~= 'Drop') and (ev ~= 'Exit') and (ev ~= 'Wait') and (not walk_outside) then
				-- p (ev)
				p "Прежде нужно снять скафандр."
				return true
			end 
			if not in_suit and walk_outside then
				p "Без скафандра снаружи Станции не выжить."
				return true
			end
			if in_suit and walk_outside and not full_tank:inside('suit') then
				p "Кислород на нуле. С пустым баллоном снаружи верная смерть."
				return true
			end
			if walk_outside and _'emergency':has "on" then
				p "Невозможно. Пока работает аварийный режим, шлюз не откроется."
				return true
			end
			return false
		end,
		}, room)


-------- Доработки библиотеки Метапарсера --------
local function get_once_tag(n)
	if type(n) == 'string' then
		return '__once_'..n
	else
		return '__once'
	end
end

std.obj.once = function(s, n)
	n = get_once_tag(n)
	if not s[n] then
		s[n] = true
		return true
	end
	return false
end

std.obj.is_once = function(s, n)
	n = get_once_tag(n)
	if s[n] then
		return true
	end
	return false
end

std.obj.enabled = function(s) return not s:disabled() end
function enabled(w) return not disabled(w) end

mp.msg.UNKNOWN_OBJ = function(w)
	if not w then
		p "Я не вижу здесь этого предмета."
	else
		p "Я не вижу здесь этого предмета "
		p ("(",w,").")
	end
end

mp.msg.Take.HAVE = "{#Firstit} и так уже у {#me/вн}."
