--$Name: Разлом$
--$Version: 1.0$
--$Author: Антон Жучков (fireton)$
require "parser/mp-ru"
require "fmt"
include "classes"

-- чтобы можно было идти по "выходам"
function mp:pre_input(str)
	local a = std.split(str)
	if #a <= 1 or #a > 4 then
		return str
	end
	if a[1] == 'в' or a[1] == 'на' or a[1] == 'во' or a[1] == "к" or a[1] == 'ко' then
		return "идти "..str
	end
	return str
end

include "dict"

function init()
	game.dsc = false;
	--mp.errhints = false;
	mp.auto_animate = false;

	--mp.autohelp = false
	mp.togglehelp = false
	pl.word = "я/мр,од,ед,1л"
	mp:MetaTranscriptOn()
end

function start(load)
	-- require("mobdebug").start()
	if not load then
		move ('suit', pl)
		move(pl, 'wakeup')
		DaemonStart(suffocate)
	end
end

include "verbs"
include "objects"

include "room_rift"
include "room_lablock"
include "room_lockroom"
include "room_equiproom"
include "room_lab"
include "room_roundabout"
include "room_subairlock"
include "room_hangar"
include "room_livings"
include "room_ridge"
include "cutscenes"

-------- 

mp.msg.HELP = function()
	p [[{$fmt b|КАК ИГРАТЬ?}^^

Вводите ваши действия в виде простых предложений вида: глагол -- существительное. Например:^
> открыть дверь^
> отпереть дверь ключом^
> взять камень^
^
Чтобы снова увидеть описание обстановки, введите "осмотреть", "осм" или просто нажмите "ввод".^
^
Чтобы осмотреть предмет, введите "осмотреть книгу" или просто "книга".^
^
Чтобы узнать какие предметы у вас с собой, наберите "инвентарь" или "инв".^
^
Для перемещений используйте простые команды, например: "идти к станции" или "к станции" или просто "станция". Обычно в описании каждой локации есть указания куда из неё можно пойти. Кроме явных направлений, можно перемещаться "внутрь" и "наружу", а также "выйти" из помещения.]]
	if not instead.tiny then
		p [[^^Вы можете воспользоваться клавишей "TAB" для автодополнения ввода.]]
	else
		p [[^^Вы можете сокращать названия объектов.]]
		p [[^^Чтобы сохранять и загружать игру используйте "сохранить" и "загрузить".]]
		if instead.tiny then
			p [[Например, "сохранить 1".]]
		end
		p [[Начать заново: "заново".]]
		if instead.reinstead then
			p [[^^Также доступны команды: !restart, !quit, !info, !save, !load и !font <размер>.]]
		end
	end
end





