Inside {
	nam = 'messroom',
	-"кают-компания",
	title = "Кают-компания",
	dsc = [[Общая комната экипажа для общения и приёма пищи. Тут стоит стол, два стула, у стены расположен пищеблок. У противоположной стены — терминал.^
				Две двери ведут в каюты: мою и Клэр. Также отсюда можно пройти в ангар.]],
	onenter = function(s)
		if s:once "enter" then
			p "Я зашёл в кают-компанию, и первое, что я увидел — листок бумаги на столе."
		end
	end,
	obj = {
		Useless {
			-"стол",
			description = "Ничего примечательного, обычный стол для глубоководных станций.",
		},
		Useless {
			-"стулья|стул",
			description = "Пара металлических стульев стоят рядом со столом.",
		},
		Useless {
			-"пищеблок",
			description = "Это наш повар. Готовит из сублиматов вкусную (нет) и здоровую пищу.",
			before_SwitchOn = "Я не голоден.",
			before_SwitchOff = "Он и так выключен",
		},
		Path {
			-"каюта Клэр,каюта|комната Клэр,комната",
			walk_to = function(s)
				if s:once "cut" then
					return 'memories'
				else
					return 'claire_room'
				end
			end,
		},
		Path {
			-"моя каюта,каюта|моя комната,комната|своя комната|своя каюта",
			walk_to = 'my_room'
		},
		Path {
			-"ангар",
			walk_to = 'sub_hangar'
		},
		'note'
	}
}

local flash_operated = function()
	_'claire_room':attr "flash"
end

Inside {
	nam = 'claire_room',
	title = "Каюта Клэр",
	out_to = 'messroom',
	dsc = function(s)
		p "Сразу видно, что Клэр покидала Станцию в спешке: кровать смята, ящики выдвинуты, на полу валяются вещи."
		mp:content(_'#bed')
		if s:has "flash" and _'flashdrive':inside 'slit' then
			p "В щели между кроватью и стеной что-то блестит."
		end
	end,

	["before_Exit,Enter"] = function(s)
		if s:hasnt "flash"  and _'flashdrive':inside 'slit' then
			p [[Я уже собрался выходить, но вдруг краем глаза уловил какой-то блеск в щели между кроватью и стеной.]]
			s:attr "flash"
		else
			return false
		end
	end,

	obj = {
		Ephe {
			-"блеск",
			nam = 'glint',
			description = "В щели между кроватью и стеной что-то есть. Похоже, это флешка."
		},
		Ephe {
			-"щель",
			nam = 'slit',
			description = function(s)
				p "Узкая щель между кроватью и стеной."
				if _'flashdrive':inside(s) then
					p "Там определённо что-то есть. Похоже, это флешка."
				end
			end,
			before_LetGo = function(s,o,w)
				p "Моя рука не пролезает в щель."
				return true
			end,
			before_Receive = function(s,o)
				if _'flashdrive':inside(s) then
					mp:xaction('TakeWith', _'flashdrive', o)
				else
					p ("Нет нужды засовывать ", o:noun 'вн', " в щель.")
				end
			end,
			before_LetGoWith = function(s,o,w)
				--pn(s, " ", o, " ", w)
				if w^'screwdriver' then
					p "Отвёртка слишком короткая, не достаёт."
					return
				end
				if w^'probe' then
					p "С помощью длинного щупа я вытолкнул флешку из щели, а затем подобрал её."
					move('flashdrive', pl)
					disable('glint')
					return
				end
				p "Ничего не выйдет."
			end,

			after_Any = function(s) 
				flash_operated()
				return false
			end,

			obj = {'flashdrive'},
			}:attr"container,open",

		obj {
			-"кровать,койка|постель",
			nam = '#bed',
			description = function(s)
				p "Кровать Клэр в беспорядке. Постель смята и не прибрана."
				mp:content(s)
			end,
			after_Enter = "Я сажусь на кровать.",
			after_Exit  = "Я встаю с кровати.",
			before_Take = "Нет необходимости.",
			before_Smell = "Постель сохранила её запах.",
			["before_Push,Pull"] = "Кровать невозможно сдвинуть, она приварена к полу.",
			}:attr "scenery,enterable,supporter",

		Useless {
			-"ящики|ящик",
			description = "Ящики наполовину выдвинуты, как будто Клэр наспех что-то искала там.",
			before_Search = "Ничего примечательного, одежда и личные вещи.",
			["before_Push,Pull"] = "В мою задачу не входит прибираться в комнате Клэр.",
		},

		Useless {
			-"личные вещи Клэр,личные вещи, вещи|одежда",
			description = "Разбросаны в беспорядке.",
		},

		Path {
			-"кают-компания",
			walk_to = 'messroom'
		}
	}
}

Inside {
	nam = 'my_room',
	title = "Моя каюта",
	out_to = 'messroom',
	--init_dsc = 'BLA',
	dsc = function(s)
		p "Каюты на станции очень маленькие. По факту, это просто закуток с кроватью и несколькими ящиками для личных вещей."
		mp:content(_'#bed')
	end,
	obj = {
		obj {
			-"кровать,койка|постель",
			nam = '#bed',
			description = function(s)
				p "Стандартная койка на коротких железных ножках, приваренных к полу. В каюте Клэр точно такая же."
				mp:content(s)
			end,
			before_LookUnder = function(s)
				if _'tool':hasnt "found" then
					p "Заглянув под кровать, я вытащил оттуда свой мультитул. Так вот где был! А ведь я искал его пару дней назад..."
					_'tool':attr "found"
					move('tool', pl)
				else
					return false
				end
			end,
			after_Enter = "Я сажусь на кровать.",
			after_Exit  = "Я встаю с кровати.",
			}:attr "scenery,enterable,supporter",
		Useless {
			-"ящики|ящик",
			description = "Там моя одежда и личные вещи.",
			before_Search = "Ничего примечательного.",
			["before_Push,Pull"] = "Нет необходимости, там нет ничего полезного.",
		},
		Useless {
			-"мои личные вещи,личные вещи, вещи|одежда",
			description = "Аккуратно сложены в ящиках.",
			before_Search = "Ничего примечательного.",
		},

		Path {
			-"кают-компания",
			walk_to = 'messroom'
		}
	}
}