# Манифест проекта в вопросах и ответах

> Данный манифест отражает субъективное мнение автора
> проекта. Субъективность не означает, что автор не верит в то, что
> пишет.

## Что это?

RE:INSTEAD может запускать игры, написанные с помощью модуля
[МЕТАПАРСЕР](https://instead.hugeping.ru/page/metaparser/) если они
не используют мультимедиа возможности
[INSTEAD](https://instead.hugeping.ru).

Код игры может проверять специальную переменную instead.tiny и не
использовать функции, которые не поддерживает RE:INSTEAD. Тогда, такая
игра будет совместима и с INSTEAD и с RE:INSTEAD.

В состав RE:INSTEAD уже входит набор игр под свободными лицензиями.

## На что похожи игры?

RE:INSTEAD это развитие идей проекта ["ПАРСЕРНОЕ
СОПРОТИВЛЕНИЕ"](https://parser.hugeping.ru/), который представляет
из себя библиотеку игр с текстовым вводом в минималистичном
оформлении.

RE:INSTEAD это бескомпромиссный перекос в сторону простоты. Только
текст, строка ввода и ваше воображение. Ведь книги -- это всего лишь
буквы на бумаге или устройстве чтения. Так почему интерактивная
литература должна быть похожа на что-то другое?

## Чем отличается от INSTEAD?

Список функций, которые поддерживаются:

- запуск игр написанных с помощью  МЕТАПАРСЕР3 (только STEAD3 API);
- начертание: обычный, жирный, наклонный;
- выравнивание слов в строке: слева, по центру, справа;
- графика: вставка иллюстраций с помощью атрибута gfx.

Не поддерживается:

- всё остальное.

Особенности:

- простое, аккуратно выглядящее приложение;
- отсутствие автодополнения и автоподсказок;
- файл icon.png в каталоге с игрой;
- размеры окна приложения (в отличие от INSTEAD) можно менять на лету.

## Зачем нужен RE:INSTEAD если есть INSTEAD?

[INSTEAD](https://instead.hugeping.ru) развивается с 2009 года. Это
зрелое приложение, которое обросло многими функциями. Интересно, что
аббревиатура STEAD означает Simple Text ADventure (простое текстовое
приключение) и это уже не вполне отражает специфику проекта.

"RE" в RE:INSTEAD можно понимать как: reinvent, resistance или rein ("
чистый" на нем.) и т.д. Появление RE:INSTEAD -- это попытка сбросить
груз наследия, избавиться от лишнего, наносного и
несущественного. Оставив только концентрат интерактивной литературы,
упакованный в формат минимализма.

## Чем отличается от INSTEAD-CLI?

[instead-cli](https://github.com/instead-hub/instead-cli)
позиционируется как инструмент для разработчика, а RE:INSTEAD -- как
интерпретатор для того, чтобы играть в игры. RE:INSTEAD --
графическое приложение. Также, его удобно использовать для
распространения сборников игр, созданных в духе минимализма и
простоты.

## Зачем?

Ради искусства.

RE:INSTEAD это попытка вернуться назад, к утопичной мечте в которой нет
места нагромождениям "фич" ради блажи и "хотелок". В мечту, где
творчество это не товар, не утилитарность и удобство, а поиск
красоты. RINSTEAD *никогда* не будет обрастать новыми функциями, но
будет продолжать делать хорошо то, для чего был создан. Делать это
просто настолько, насколько это возможно, понимая простоту, как
простоту устройства, а не желания пользователей.

На создание RE:INSTEAD повлияли:

- редактор lite;
- ОС Plan9 и 9front;
- INSTEAD.

## И всё-таки, зачем нужна урезанная версия INSTEAD, если есть обычная?

Как что-то простое может быть лучше сложного, если сложное обладает
всеми функциями простого?

Простая вещь часто надёжней, ей проще пользоваться. В сфере
программирования -- простые программы проще поддерживать, простота
часто воспринимается как красота. Кроме того, не использовать
какую-либо функцию -- это не то же самое, что не иметь этой функции
вообще.

Например, возьмём велокомпьютер. У многих велолюбителей на руле
вилосипеда есть спидометр. Легко убедиться на практике, что не
смотреть на скорость во время поездки это не то же самое, что вообще
не иметь велокомпьютера. Пока он стоит на руле, то всё-равно
присутствует в зоне вашего внимания. Так же как и другие возможности:
тормоза, переключатели скоростей, зеркало заднего вида,
гудок... Что-ещё можно навесить на руль?

А теперь представьте себе односкоростной велосипед с глухой передачей,
без велокомпьютера, зеркала, гудка... Остаётся только наслаждаться
поездкой.

RE:INSTEAD как раз такой велосипед. Конечно, у каждого человека свой
минимальный порог аскетики, на который он готов пойти. Если RE:INSTEAD
не для вас -- вы не одиноки.

С точки зрения автора интерактивной литературы, ограничения тоже
работают как стимул. Автору не нужно думать над оформлением, нюансами
настройки парсера и прочими мелочами. Достаточно написать текст.

С точки зрения программиста, RE:INSTEAD гораздо проще INSTEAD. Его
микроядро на "C" очень маленькое, а платформозависимая часть
локализована в файле platform.c. На данный момент RE:INSTEAD
собирается для: Linux, Windows, Plan9. Скорее всего, нет проблем для
портирования его на любую, хотя бы частично, POSIX-совместимую
платформу. Если же в составе пакетов вашей ОС имеется SDL2, то, почти
наверняка, RE:INSTEAD может быть собран в ней без изменений. Если
SDL2 нет, достаточно реализовать API в platform.c.

## Я прочитал манифест и всё-ещё не понимаю, зачем это нужно?

Это не нужно.

## Нужно добавить в проект ...

Нет. Но если хочется, вы почти наверняка можете сделать это на Lua.

## Я хочу писать игры с текстовым вводом!

Добро [пожаловать](http://instead-games.ru)!
